--- lib/crypto/openssl/crypto_mod.h.orig	2017-12-05 11:36:22.000000000 -0600
+++ lib/crypto/openssl/crypto_mod.h	2017-12-19 06:06:40.000000000 -0600
@@ -39,7 +39,7 @@
 
 /* 1.1 standardizes constructor and destructor names, renaming
  * EVP_MD_CTX_create and EVP_MD_CTX_destroy. */
-#if OPENSSL_VERSION_NUMBER < 0x10100000L
+#if OPENSSL_VERSION_NUMBER < 0x10100000L || defined(LIBRESSL_VERSION_NUMBER)
 #define EVP_MD_CTX_new EVP_MD_CTX_create
 #define EVP_MD_CTX_free EVP_MD_CTX_destroy
 #endif
--- lib/crypto/openssl/hmac.c.orig	2017-12-05 11:36:22.000000000 -0600
+++ lib/crypto/openssl/hmac.c	2017-12-19 06:06:40.000000000 -0600
@@ -55,7 +55,7 @@
 #include <openssl/hmac.h>
 #include <openssl/evp.h>
 
-#if OPENSSL_VERSION_NUMBER < 0x10100000L
+#if OPENSSL_VERSION_NUMBER < 0x10100000L || defined(LIBRESSL_VERSION_NUMBER)
 
 /* OpenSSL 1.1 makes HMAC_CTX opaque, while 1.0 does not have pointer
  * constructors or destructors. */
--- plugins/preauth/pkinit/pkinit_crypto_openssl.c.orig	2017-12-05 11:36:22.000000000 -0600
+++ plugins/preauth/pkinit/pkinit_crypto_openssl.c	2017-12-19 06:06:40.000000000 -0600
@@ -187,7 +187,7 @@
     (*_x509_pp) = PKCS7_cert_from_signer_info(_p7,_si)
 #endif
 
-#if OPENSSL_VERSION_NUMBER < 0x10100000L
+#if OPENSSL_VERSION_NUMBER < 0x10100000L || defined(LIBRESSL_VERSION_NUMBER)
 
 /* 1.1 standardizes constructor and destructor names, renaming
  * EVP_MD_CTX_{create,destroy} and deprecating ASN1_STRING_data. */
@@ -3047,7 +3047,7 @@
     return retval;
 }
 
-#if OPENSSL_VERSION_NUMBER >= 0x10100000L
+#if OPENSSL_VERSION_NUMBER >= 0x10100000L && !defined(LIBRESSL_VERSION_NUMBER)
 
 /*
  * We need to decode DomainParameters from RFC 3279 section 2.3.3.  We would
--- plugins/preauth/pkinit/pkinit_crypto_openssl.h.orig	2017-12-05 11:36:22.000000000 -0600
+++ plugins/preauth/pkinit/pkinit_crypto_openssl.h	2017-12-19 06:06:40.000000000 -0600
@@ -46,7 +46,7 @@
 #include <openssl/asn1.h>
 #include <openssl/pem.h>
 
-#if OPENSSL_VERSION_NUMBER >= 0x10100000L
+#if OPENSSL_VERSION_NUMBER >= 0x10100000L && !defined(LIBRESSL_VERSION_NUMBER)
 #include <openssl/asn1t.h>
 #else
 #include <openssl/asn1_mac.h>
